# -*- encoding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2010 E.Samyn - info@open-shift.com
# Author: E.Samyn
#
# This file is part of the hr_extension module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; 
# If not, see <http://www.gnu.org/licenses/> or  write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields, osv
from mx import DateTime

import datetime

#--- job level ---
class hr_job_level(osv.osv):
	_name = "hr.job.level"
	_description = "This object allows to add different levels (qualification/seniority) to a job and a related minimum wage (legal/internal) for the level"
	_columns = {
		'job_id': fields.many2one('hr.job', 'Job'),
		'name' : fields.char('Label', size=64, required=True),
		'job_level': fields.char('Level', size=60),
		'mini_wage': fields.float('Level minimum wage',digits=(10,2)),
	}
hr_job_level()

class hr_employee(osv.osv):
	_name = "hr.employee"
	_description = "Employee extension"
	_inherit = "hr.employee"

	def _current_employee_age(self,cr,uid,ids,field_name,arg,context):
		res = {}
		today = datetime.date.today()
		dob = today
		for employee in self.browse(cr, uid, ids):			
			if employee.birthday:
				dob = DateTime.strptime(employee.birthday,'%Y-%m-%d')			
			res[employee.id] = today.year - dob.year
		return res
												
	_columns = {
 		'age' : fields.function(_current_employee_age,method=True,string='Age',type='integer',store=True),
	 	'can_use_perso_email' : fields.boolean('Can use personal email'),
		'emergency_contact' : fields.char('Emergency contact', size=60),
		'emergency_phone' : fields.char('Emergency phone', size=60),	
		'current_job_level' : fields.many2one('hr.job.level','Current job level'),
	}
		
hr_employee()